'use strict';

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _postcss = require('postcss');

var _postcss2 = _interopRequireDefault(_postcss);

var _ = require('..');

var _2 = _interopRequireDefault(_);

var _cleanCss = require('clean-css');

var _cleanCss2 = _interopRequireDefault(_cleanCss);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

console.info('Building Tailwind!');

_fs2.default.readFile('./css/tailwind.css', (err, css) => {
  (0, _postcss2.default)([(0, _2.default)()]).process(css, {
    from: './css/tailwind.css',
    to: './dist/tailwind.css',
    map: { inline: false }
  }).then(result => {
    _fs2.default.writeFileSync('./dist/tailwind.css', result.css);
    if (result.map) {
      _fs2.default.writeFileSync('./dist/tailwind.css.map', result.map);
    }
    return result;
  }).then(result => {
    const minified = new _cleanCss2.default().minify(result.css);
    _fs2.default.writeFileSync('./dist/tailwind.min.css', minified.styles);
  }).catch(error => console.log(error));
});

console.log('Finished Building Tailwind!');