'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function ({ padding, margin, negativeMargin }) {
  return _lodash2.default.flatten([definePadding(padding), defineMargin(margin), (0, _defineClasses2.default)({
    'mr-auto': {
      'margin-right': 'auto'
    },
    'ml-auto': {
      'margin-left': 'auto'
    },
    'mx-auto': {
      'margin-left': 'auto',
      'margin-right': 'auto'
    }
  }), defineNegativeMargin(negativeMargin)]);
};

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _defineClasses = require('../util/defineClasses');

var _defineClasses2 = _interopRequireDefault(_defineClasses);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function definePadding(padding) {
  return _lodash2.default.flatMap(padding, (size, modifier) => {
    return (0, _defineClasses2.default)({
      [`pt-${modifier}`]: {
        'padding-top': `${size}`
      },
      [`pr-${modifier}`]: {
        'padding-right': `${size}`
      },
      [`pb-${modifier}`]: {
        'padding-bottom': `${size}`
      },
      [`pl-${modifier}`]: {
        'padding-left': `${size}`
      },
      [`px-${modifier}`]: {
        'padding-left': `${size}`,
        'padding-right': `${size}`
      },
      [`py-${modifier}`]: {
        'padding-top': `${size}`,
        'padding-bottom': `${size}`
      },
      [`p-${modifier}`]: {
        'padding': `${size}`
      }
    });
  });
}

function defineMargin(margin) {
  return _lodash2.default.flatMap(margin, (size, modifier) => {
    return (0, _defineClasses2.default)({
      [`mt-${modifier}`]: {
        'margin-top': `${size}`
      },
      [`mr-${modifier}`]: {
        'margin-right': `${size}`
      },
      [`mb-${modifier}`]: {
        'margin-bottom': `${size}`
      },
      [`ml-${modifier}`]: {
        'margin-left': `${size}`
      },
      [`mx-${modifier}`]: {
        'margin-left': `${size}`,
        'margin-right': `${size}`
      },
      [`my-${modifier}`]: {
        'margin-top': `${size}`,
        'margin-bottom': `${size}`
      },
      [`m-${modifier}`]: {
        'margin': `${size}`
      }
    });
  });
}

function defineNegativeMargin(negativeMargin) {
  return _lodash2.default.flatMap(negativeMargin, (size, modifier) => {
    size = `${size}` === '0' ? `${size}` : `-${size}`;

    return (0, _defineClasses2.default)({
      [`-mt-${modifier}`]: {
        'margin-top': `${size}`
      },
      [`-mr-${modifier}`]: {
        'margin-right': `${size}`
      },
      [`-mb-${modifier}`]: {
        'margin-bottom': `${size}`
      },
      [`-ml-${modifier}`]: {
        'margin-left': `${size}`
      },
      [`-mx-${modifier}`]: {
        'margin-left': `${size}`,
        'margin-right': `${size}`
      },
      [`-my-${modifier}`]: {
        'margin-top': `${size}`,
        'margin-bottom': `${size}`
      },
      [`-m-${modifier}`]: {
        'margin': `${size}`
      }
    });
  });
}