'use strict';

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _postcss = require('postcss');

var _postcss2 = _interopRequireDefault(_postcss);

var _stylefmt = require('stylefmt');

var _stylefmt2 = _interopRequireDefault(_stylefmt);

var _substitutePreflightAtRule = require('./lib/substitutePreflightAtRule');

var _substitutePreflightAtRule2 = _interopRequireDefault(_substitutePreflightAtRule);

var _evaluateTailwindFunctions = require('./lib/evaluateTailwindFunctions');

var _evaluateTailwindFunctions2 = _interopRequireDefault(_evaluateTailwindFunctions);

var _generateUtilities = require('./lib/generateUtilities');

var _generateUtilities2 = _interopRequireDefault(_generateUtilities);

var _substituteHoverableAtRules = require('./lib/substituteHoverableAtRules');

var _substituteHoverableAtRules2 = _interopRequireDefault(_substituteHoverableAtRules);

var _substituteFocusableAtRules = require('./lib/substituteFocusableAtRules');

var _substituteFocusableAtRules2 = _interopRequireDefault(_substituteFocusableAtRules);

var _substituteResponsiveAtRules = require('./lib/substituteResponsiveAtRules');

var _substituteResponsiveAtRules2 = _interopRequireDefault(_substituteResponsiveAtRules);

var _substituteScreenAtRules = require('./lib/substituteScreenAtRules');

var _substituteScreenAtRules2 = _interopRequireDefault(_substituteScreenAtRules);

var _substituteClassApplyAtRules = require('./lib/substituteClassApplyAtRules');

var _substituteClassApplyAtRules2 = _interopRequireDefault(_substituteClassApplyAtRules);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const plugin = _postcss2.default.plugin('tailwind', config => {
  if (_lodash2.default.isUndefined(config)) {
    config = require('../defaultConfig');
  }

  if (_lodash2.default.isString(config)) {
    config = require(_path2.default.resolve(config));
  }

  return (0, _postcss2.default)([(0, _substitutePreflightAtRule2.default)(config), (0, _evaluateTailwindFunctions2.default)(config), (0, _generateUtilities2.default)(config), (0, _substituteHoverableAtRules2.default)(config), (0, _substituteFocusableAtRules2.default)(config), (0, _substituteResponsiveAtRules2.default)(config), (0, _substituteScreenAtRules2.default)(config), (0, _substituteClassApplyAtRules2.default)(config), _stylefmt2.default]);
});

plugin.defaultConfig = function () {
  return _lodash2.default.cloneDeep(require('../defaultConfig'));
};

module.exports = plugin;