'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = findMixin;

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function findMixin(css, mixin, onError) {
  const matches = [];

  css.walkRules(rule => {
    if (rule.selectors.includes(mixin) && rule.parent.type == 'root') {
      matches.push(rule);
    }
  });

  if (_lodash2.default.isEmpty(matches) && _lodash2.default.isFunction(onError)) {
    onError();
  }

  return _lodash2.default.flatten(matches.map(match => match.clone().nodes));
}